import * as os from 'node:os';
import * as core from '@contentlayer/core';
import { Chunk, OT, pipe, S, T } from '@contentlayer/utils/effect';
import { fetchDatabasePages } from '../notion/fetchDatabasePages.js';
import { makeCacheItem } from './makeCacheItem.js';
export const fetchAllDocuments = ({ databaseTypeDefs, previousCache, schemaDef, options }) => pipe(T.forEachPar_(databaseTypeDefs, (databaseTypeDef) => pipe(fetchDatabasePages({ databaseTypeDef }), S.chain((pages) => pipe(S.effect(pipe(T.forEachParN_(pages, os.cpus().length, (page) => makeCacheItem({
    page,
    documentTypeDef: schemaDef.documentTypeDefMap[databaseTypeDef.name],
    databaseTypeDef,
    previousCache,
    options,
})))), OT.withStreamSpan('@contentlayer/source-notion/fetchData:makeCacheItems'))), S.runCollect, T.chain((chunks) => T.reduce_(chunks, [], (z, a) => T.succeed([...z, ...a]))))), T.map((chunks) => Chunk.reduce_(chunks, [], (z, a) => [...z, ...a])), T.map((documents) => ({
    cacheItemsMap: Object.fromEntries(documents.map((_) => [_.cacheItem.document._id, _.cacheItem])),
})), OT.withSpan('@contentlayer/source-notion/fetchData:fetchAllDocuments'), T.mapError((error) => new core.SourceFetchDataError({ error, alreadyHandled: false })));
//# sourceMappingURL=fetchAllDocuments.js.map